VERA_LADDR := $9F20
VERA_MADDR := $9F21
VERA_HADDR := $9F22
VERA_DATA0 := $9F23
CHKIN := $FFC6
CLRCHN := $FFCC
MACPTR := $FF44
GETIN := $FFE4
sprite_attr_1 = $70
sprite_attr_2 = $72
R0L=2
R0H=3
R1L=4
R1H=5
R14L=$1E
R14H=$1F
R15L=$20
palptr = $26

.org $0700
 lda 1
 pha
    stz 1
    ldx #4
	jsr CHKIN
    lda #70
    sta R0L
    lda R15L
    beq Hipage

    wai
    ldx #$36
    ldy #$FE         ; start at sprite 70
    lda #%01001001   ; and decrement
    jsr swapsprites

    stz R15L
    stz VERA_LADDR
    stz VERA_MADDR
    bra Hiaddr

Hipage:
    ldx #$0E
    ldy #$FC
    lda #%01000001
    jsr swapsprites

    lda #1
    sta R15L
    stz VERA_LADDR
    lda #$46
    sta VERA_MADDR
Hiaddr:
    lda #%00010000
    sta VERA_HADDR
loop1:
	ldx #$23
	ldy #$9F
	lda #255
	sec
	jsr MACPTR
	dec R0L
	bne loop1
	ldx #$23
	ldy #$9F
	lda #70
	sec
	jsr MACPTR

; now load the palette for the frame to $0400
	ldx #0
	ldy #$04
	lda #128
	clc
	jsr MACPTR
	ldx #$80
	ldy #$04
	lda #128
	clc
	jsr MACPTR
	ldx #0
	ldy #$05
	lda #128
	clc
	jsr MACPTR
	ldx #$80
	ldy #$05
	lda #128
	clc
	jsr MACPTR
    jsr CLRCHN
 pla
 sta 1
	rts



swapsprites:
          stx VERA_LADDR
          sty VERA_MADDR
          sta VERA_HADDR

          ldx #35
          ldy #35

          lda #%00001100
sprloop1: sta VERA_DATA0
          dex
          bne sprloop1
sprloop2: stz VERA_DATA0
          dey
          bne sprloop2




          stz VERA_LADDR
          lda #$FA       ; THE PALETTE
          sta VERA_MADDR
          lda #%00010001
          sta VERA_HADDR

          stz palptr
          lda #$04
          sta palptr+1
          ldx #2
          ldy #0
ploop1:   lda (palptr),y
          sta VERA_DATA0
          iny
          bne ploop1
          inc palptr+1
          dex
          bne ploop1
          rts



