$Console
Type SVIDHeaderType
    ID As String * 4
    VTYPE As _Unsigned _Byte
    BPP As _Unsigned _Byte
    FPS As _Unsigned _Byte
    SpriteWidth As _Unsigned _Byte
    SpriteHeight As _Unsigned _Byte
    FrameWidth As _Unsigned Integer
    FrameHeight As _Unsigned Integer
    NumFrames As _Unsigned Long
    EXTRA As String * 15
End Type


Type BMPHeaderType
    id As String * 2 'Should be "BM"
    size As Long 'Size of the data
    rr1 As Integer '
    rr2 As Integer '
    offset As Long 'Position of start of pixel data
    horz As Long '
    wid As Long 'Image width
    hei As Long 'Image height
    planes As Integer '
    bpp As Integer 'Should read 8 for a 256 colour image
    pakbyte As Long '
    imagebytes As Long 'Width*Height
    xres As Long '
    yres As Long '
    colch As Long '
    ic As Long '
    pal As String * 1024 'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type

VERA_DEFAULT:
Data 0,0,255,15,0,8,254,10,76,12,197,0,10,0,231,14,133,13,64,6,119,15,51,3,119,7,246,10,143,0,187,11,0,0,17,1,34,2,51,3,68,4,85,5,102,6,119,7,136,8,153,9,170,10,187,11,204,12,221,13,238
Data 14,255,15,17,2,51,4,68,6,102,8,136,10,153,12,187,15,17,2,34,4,51,6,68,8,85,10,102,12,119,15,0,2,17,4,17,6,34,8,34,10,51,12,51,15,0,2,0,4,0,6,0,8,0,10,0,12,0,15,33,2,67,4,100,6,134,8
Data 168,10,201,12,235,15,17,2,50,4,83,6,116,8,149,10,182,12,215,15,16,2,49,4,81,6,98,8,130,10,163,12,195,15,16,2,48,4,64,6,96,8,128,10,144,12,176,15,33,1,67,3,100,5,134,7,168,9,201,11,251
Data 13,33,1,66,3,99,4,132,6,165,8,198,9,247,11,32,1,65,2,97,4,130,5,162,6,195,8,243,9,32,1,64,2,96,3,128,4,160,5,192,6,240,7,33,1,67,3,101,4,134,6,168,8,202,9,252,11,33,1,66,2,100,3,133
Data 4,166,5,200,6,249,7,32,0,65,1,98,1,131,2,164,2,197,3,246,3,32,0,65,0,97,0,130,0,162,0,195,0,243,0,34,1,68,3,102,4,136,6,170,8,204,9,255,11,34,1,68,2,102,3,136,4,170,5,204,6,255,7,34
Data 0,68,1,102,1,136,2,170,2,204,3,255,3,34,0,68,0,102,0,136,0,170,0,204,0,255,0,18,1,52,3,86,4,104,6,138,8,172,9,207,11,18,1,36,2,70,3,88,4,106,5,140,6,159,7,2,0,20,1,38,1,56,2,74,2,92
Data 3,111,3,2,0,20,0,22,0,40,0,42,0,60,0,63,0,18,1,52,3,70,5,104,7,138,9,156,11,191,13,18,1,36,3,54,4,72,6,90,8,108,9,127,11,2,1,20,2,22,4,40,5,42,6,60,8,63,9,2,1,4,2,6,3,8,4,10,5,12,6
Data 15,7,18,2,52,4,70,6,104,8,138,10,156,12,190,15,17,2,35,4,53,6,71,8,89,10,107,12,125,15,1,2,19,4,21,6,38,8,40,10,58,12,60,15,1,2,3,4,4,6,6,8,8,10,9,12,11,15

Common Shared ImageWidth
Common Shared ImageHeight
Common Shared SprWidth
Common Shared SprHeight
Common Shared Palsize
Common Shared UsedCols$
Common Shared MovieName$
Common Shared MovieFPS$
Common Shared TName$
Common Shared TPath$
Common Shared DName$
Common Shared HomeDir$
Common Shared ProjectHome$
Common Shared ProjectDir$
Common Shared Slash$
Common Shared CopyCmd$
Common Shared MoveCmd$
Common Shared SystemOpen$
Common Shared UseExisting
Common Shared UsingPalette
Common Shared ProjectFPS%
Common Shared Make4BPP
Common Shared UseDither
Common Shared DoHighRes
Common Shared DoPalShift

Dim Shared Magick$
Dim Shared wid
Dim Shared hei
Dim Shared Show&, Show2&
ReDim Shared ImageData(0) As _Unsigned _Byte
ReDim Shared Sprite(0 To ((SprWidth * SprHeight) - 1)) As _Unsigned _Byte
ReDim Shared Sprite4BPP(0 To (((SprWidth * SprHeight) / 2) - 1)) As _Unsigned _Byte
Dim Shared VERAPAL(0 To 255) As VPALTYPE
Dim Shared VERAPAL4B(0 To 31) As VPALTYPE
Dim Shared FrameCount As _Unsigned Long
Dim Shared FrameExt$

Dim Shared VideoHeader As SVIDHeaderType
VideoHeader.ID = "SPRV"
VideoHeader.VTYPE = 1



$If WINDOWS Then
    Slash$ = "\"
    CopyCmd$ = "COPY "
    MoveCmd$ = "MOVE "
    SystemOpen$ = "START "
    HomeDir$=_DIR$("APPDATA")
    HomeDir$=LEFT$(HomeDir$,(LEN(HomeDir$)-1))
$Else
    Slash$ = "/"
    CopyCmd$ = "cp "
    MoveCmd$ = "mv "
    HomeDir$ = Environ$("HOME")
    SystemOpen$ = "xdg-open "
$End If

ProjectHome$ = HomeDir$ + Slash$ + "x16vidprojects"

If Not _DirExists(ProjectHome$) Then
    MkDir ProjectHome$
    MkDir ProjectHome$ + Slash$ + "GRAYSCALE"
    MkDir ProjectHome$ + Slash$ + "8BPP"
    MkDir ProjectHome$ + Slash$ + "4BPP"
End If

ChDir _StartDir$

If _CommandCount > 1 Then BadCommandLine
If _CommandCount = 0 Then GoTo skipprocesscommandline
TName$ = Command$(1)

tmp$ = GetFilePath(TName$)

If _FileExists(TName$) And (tmp$ = "") Then
    TName$ = _StartDir$ + Slash$ + TName$
End If

GoTo StartMeUp1


skipprocesscommandline:
Choice = GetUserChoice

If Choice = 2 Then
    TFolder$ = _SelectFolderDialog$("SELECT FRAME DIRECTORY", ProjectHome$)
    If TFolder$ = "" Then System
    TPath$ = TFolder$
    ChDir TFolder$
    InFrameFolder = -1
    UseExisting = -1
    DName$ = TFolder$
    SetUpMovieParameters
    GoTo StartMeUp2
End If


TName$ = _OpenFileDialog$("X16 Video Convertor - Select Video File to Convert", "", "*.mpg|*.MPG|*.mpeg|*.MPEG|*.MP4|*.mp4|*.mkv|*.MKV|*.avi|*.AVI", "Movie Files", -1)

If TName$ = "" Then System

StartMeUp1:
SetUpMovieParameters
If Not UseExisting Then
    PName$ = GetFileName(TName$)
    ChDir ProjectHome$

    subpath$ = "8BPP"
    VideoHeader.BPP = 8
    If Make4BPP Then subpath$ = "4BPP": VideoHeader.BPP = 4
    TPath$ = subpath$ + Slash$ + GetFileName(TName$)
    Print TPath$
    Print _CWD$
    Print _DirExists(TPath$)
    If _DirExists(TPath$) Then
        ChDir TPath$
    Else
        MkDir TPath$
        ChDir TPath$
    End If
    If Not _DirExists("frames") Then
        MkDir "frames"
    End If
    FFMpeg_ExtractFrames
    ChDir "frames"
    NewProj = -1
End If


StartMeUp2:
CheckForFrames

If FrameCount = 0 Then
    Beep
    _Dest _Console
    Print "No framefiles found !"
    Print
    _Dest 0
    Print "No framefiles found !"
    Print
    _MessageBox "NO FRAME FILES", "No frame files were found at: " + TPath$, "error"
    End
Else
    Print
    Print " "; FrameCount; " Frames"
    VideoHeader.NumFrames = FrameCount
End If

SetUpMovieParameters
GetColCount
Width 80, 30
Cls
Print
Color 6
Print "Converting " + DName$
Color 4
Print FrameCount;
Color 14
Print " " + FrameExt$;
Color 6
Print " frames."
_Dest _Console
Cls
Print
Color 3
Print "Converting " + DName$
Locate 10, 1
Print
Color 9
Print FrameCount;
Color 3
Print " " + FrameExt$ + " frames."
_Dest 0
Locate 10, 1
Print
Color 9
Print FrameCount;
Color 3
Print " " + FrameExt$ + " frames."
_Dest _Console


MovieName$ = GetTargetName
AudioTrackName$ = GetFileName(MovieName$) + ".SVA"
If NewProj Then
    Pref$ = ".." + Slash$: MovieName$ = Pref$ + MovieName$: AudioTrackName$ = Pref$ + AudioTrackName$
    CMD$ = MoveCmd$ + "../audio.out " + AudioTrackName$
    DualPrint CMD$
    Shell CMD$
End If

X = _MessageBox("Preview ?", "Show preview window while converting ?", "yesno", "question", 0)
WantsPreview = (X = 1)

If _FileExists(MovieName$) Then Kill MovieName$

Open MovieName$ For Binary As #3

Put #3, , VideoHeader


SUFFIX$ = "0000000"
For i& = 1 To FrameCount
    If i& = 10 Then SUFFIX$ = "000000"
    If i& = 100 Then SUFFIX$ = "00000"
    If i& = 1000 Then SUFFIX$ = "0000"
    If i& = 10000 Then SUFFIX$ = "000"
    If i& = 100000 Then SUFFIX$ = "00"
    DOFILE$ = SUFFIX$ + Mid$(Str$(i&), 2) + FrameExt$
    LoadImage DOFILE$
    If WantsPreview Then Showit
    For Y = 0 To (ImageHeight - SprHeight) Step SprHeight
        For X = 0 To (ImageWidth - SprWidth) Step SprWidth
            GetSprite X, Y
            Put #3, , Sprite()
        Next
    Next
    If UsingPalette Then Put #3, , VERAPAL()
Next

Close 3
_Dest _Console
Color 15: Print: Print "DONE !": Print
If UseExisting Then
    Shell SystemOpen$ + " ."
Else
    Shell SystemOpen$ + " .."
End If
System

Function GetUserChoice% ()
    Screen 0
    Width 50, 12
    _Font 17
    _Title "X16 Video Convertor"
    _ScreenShow
    _Dest 0
    Color 15, 0
    Cls
    Locate 4, 12: Print "X16 Video Conversion Tool !"
    Locate 7, 3: Color 2
    Print "Select ";: Color 10: Print "YES";: Color 2
    Print " to open a New video file !"

    Locate 9, 3: Color 2
    Print "Select ";: Color 10: Print "NO";: Color 2
    Print " to process already extracted frames !"

    X = _MessageBox("New Video File", "Do You want to Open a New Video File ?", "yesnocancel", "question", 1)
    If X = 0 Then System
    GetUserChoice = X
End Function



Sub FFMpeg_ExtractFrames
    DName$ = GetFileName(TName$) + GetFileExt(TName$)
    If InStr(1, TName$, Chr$(32)) > 0 Then
        TName$ = "'" + TName$ + "'"
    End If
    CMD$ = "ffmpeg  -i " + TName$ + " -vf fps=" + MovieFPS$ + "/1 -c:v png frames/%08d.png"
    _Dest _Console
    Cls
    Print
    Print "EXTRACTING FRAMES": Print
    Print CMD$: Print
    _Dest 0
    Cls
    Print: Print
    Print "EXTRACTING FRAMES": Print
    Print CMD$: Print
    _Dest _Console
    Shell CMD$
    _Dest 0
    Print
    DualPrint "PREPARING TO EXTRACT AUDIO"
    DualPrint " (8 bit, monoaural)"
    DualPrint ""
    _Dest 0
    Print
    defaultsr$ = "16400"
    dorateagain:
    AudioRate$ = _InputBox$("Video Project - Audio Rate", "Enter Desired Sample Rate.", defaultsr$)
    If AudioRate$ = "" Then GoSub rateerror: GoTo dorateagain
    If IsNum(AudioRate$) Then
        ar = Val(AudioRate$)
        If ar < 8000 Or ar > 32000 Then GoSub rateerror: GoTo dorateagain
    Else
        GoSub rateerror
        GoTo dorateagain
    End If
    CMD$ = "ffmpeg -i " + TName$ + " -f s8 -acodec pcm_s8 -ac 1  -ar " + AudioRate$ + " audio.out"
    DualPrint CMD$
    DualPrint ""
    _Dest _Console
    Shell CMD$
    _Dest 0
    Cls
    Exit Sub
    rateerror:
    _MessageBox "INPUT ERROR", "Audio Rate must be between 8000 & 32000 !" + Chr$(13) + "TRY AGAIN", "warning"
    Return
End Sub


Sub CheckForFrames
    frm1suff$ = "00000001"
    Ext$ = ".png"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    Ext$ = ".bmp"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    Ext$ = ".jpg"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    Ext$ = ".jpeg"
    cfile$ = frm1suff$ + Ext$
    If _FileExists(cfile$) Then GoTo getCount
    FrameCount = 0
    FrameExt$ = "NOT FOUND"
    Exit Sub
    getCount:
    CountFrames Ext$
    If FrameCount > 0 Then FrameExt$ = Ext$
End Sub

Sub SetUpMovieParameters
    Static ParamsSet
    If ParamsSet Then Exit Sub
    DoHighRes = DoHighResolution
    If DoHighRes Then
        ImageWidth = 192
        ImageHeight = 128
        SprWidth = 32
        SprHeight = 32
    Else
        ImageWidth = 160
        ImageHeight = 112
        SprWidth = 32
        SprHeight = 16
    End If
    UseDither = DoDithering
    VideoHeader.FrameWidth = ImageWidth
    VideoHeader.FrameHeight = ImageHeight
    VideoHeader.SpriteWidth = SprWidth
    VideoHeader.SpriteHeight = SprHeight
    Palsize = 512
    ReDim Sprite(0 To (((SprWidth * SprHeight)) - 1))
    UsingPalette = -1
    MovieFPS$ = SetFrameRate
    VideoHeader.FPS = Val(MovieFPS$)
    ParamsSet = -1
End Sub

Function DoHighResolution% ()
    ResolutionMessage
    tmp = _MessageBox(Chr$(34) + "Hi-Res" + Chr$(34) + " Mode ?", "Do you want to enable:  192 x 168 output ?", "yesno", "question", 0)
    DoHighResolution = (tmp = 1)
End Function

Function DoDithering% ()
    DitheringMessage
    tmp = _MessageBox("DITHERING", "Do you want to use Floyd Steinberg dithering ?", "yesno", "question", 0)
    DoDithering = (tmp = 1)
End Function

Function SetFrameRate$ ()
    If DoHighRes Then
        default$ = "6"
    Else
        default$ = "10"
    End If
    FrameRateMessage
    getframes:
    tmp$ = _InputBox$("Set X16 Project Frame Rate", "Enter desired FPS:", default$)
    If tmp$ = "" Then System
    If IsNum(tmp$) And Val(tmp$) < 31 And Val(tmp$) > 3 Then
        SetFrameRate = tmp$
        Exit Function
    End If
    _MessageBox "Invalid Input", tmp$ + " is an invalid input" + Chr$(13) + "Try Again", "warning"
    GoTo getframes
End Function


Sub FrameRateMessage
    Screen 0
    _Title "Project Frame Rate"
    _Dest 0
    Width 64, 17
    _Font 17
    Cls
    Color 7
    For I = 1 To 3: Print: Next
    Color 2
    Print " X16 Video Convertor";
    Color 7
    Print " will let you set";
    Color 15
    Print " any possible Frame rate";
    Color 7
    Print " up to ";
    Color 10
    Print "30";
    Color 2
    Print " fps"
    Color 7
    Print
    Print " This does not mean the ";
    Color 15
    Print "Commander X16";
    Color 10
    Print " can play";
    Color 7
    Print " that";
    Color 10
    Print " Frame Rate."
    Print
    Print
    Color 10
    Print " The Convertor assumes some Homework on the part of the User!"
    Color 2
    Print
    Print " Recommended Frame Rates are in the range of 5 to 15 fps."
    Color 14
    Print " (";
    Color 2
    Print "see user guide";
    Color 14
    Print ")"
End Sub

Sub ResolutionMessage
    Screen 0
    _Title "MAKE  " + Chr$(34) + "High Res" + Chr$(34) + " Video ?"
    _Dest 0
    Width 64, 17
    _Font 17
    Cls
    Color 7
    For I = 1 To 2: Print: Next
    Color 7
    Print " X16 Video Convertor ";
    Color 2
    Print Chr$(34) + "High Resolution Mode" + Chr$(34);
    Color 7
    Print " is ";
    Color 10
    Print " 192 x 128 "
    Print
    Color 7
    Print " This is ";
    Color 14
    Print "PUSHING ";
    Color 7: Print "the ";
    Color 15
    Print "Commander X16"
    Print

    Color 7
    Print " Recommended Frame Rate for ";

    Color 15: Print "8";
    Color 2: Print "bpp ";
    Color 10: Print "192 ";
    Color 2: Print "x ";
    Color 10: Print "128 ";
    Color 7: Print "is ";
    Color 15: Print "6 ";
    Color 2: Print "fps."

    Color 7
    Print
    Print " Recommended Frame Rate for ";

    Color 15: Print "4";
    Color 2: Print "bpp ";
    Color 10: Print "192 ";
    Color 2: Print "x ";
    Color 10: Print "128 ";
    Color 7: Print "is ";
    Color 15: Print "12 ";
    Color 2: Print "fps."
    Print
    Print
    Color 7
    Print " Standard Resoltion is ";
    Color 15
    Print "160 x 112."
    Print
    Color 14
    Print " (";
    Color 2
    Print "see user guide";
    Color 14
    Print ")"
End Sub

Sub DitheringMessage
    Screen 0
    _Title "DITHERING"
    _Dest 0
    Width 64, 17
    _Font 17
    Cls
    Color 7
    For I = 1 To 2: Print: Next
    Color 7
    Print " X16 Video Convertor can use:";
    Color 2
    Print Chr$(34) + " Floyd Steinberg dithering" + Chr$(34);
    Print

    Color 7
    Print " This ";

    Color 15: Print "can ";
    Color 7
    Print "improve color appearance."
    Print
    Print " But may look worse on Videos with  ";

    Color 15: Print "few colors.";
    Print
    Print
    Color 14
    Print " (";
    Color 2
    Print "see user guide";
    Color 14
    Print ")"
End Sub



Sub GetColCount
    getcolorcount:
    CFlag = 0
    UsedCols$ = ""
    DefUse$ = "256"
    MSG$ = "Enter # of Palette colors to Use. (16-256)"
    X$ = _InputBox$("HOW MANY COLORS", MSG$, DefUse$)
    If Not IsNum(X$) Then
        _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
        GoTo getcolorcount
    End If
    C% = Val(X$)
    If C% < 16 Or C% > 256 Then
        _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
        GoTo getcolorcount
    End If
    UsedCols$ = X$
End Sub

Function GetTargetName$ ()
    CFlag = 0
    DefVal$ = GetFileName(DName$) + ".SPV"
    MSG$ = "Output File Name:"
    X$ = _InputBox$("OUTPUT MOVIE", MSG$, DefVal$)
    If GetFileExt(X$) = "" Then X$ = X$ + ".SPV"
    GetTargetName = X$
End Function


Sub CountFrames (ext$)
    Cls: Print: Color 11
    Locate 2, 2: Print "Counting Frames"
    SUFFIX$ = "0000000"
    FrameCount = 0
    Current& = 1
    Do
        If Current& = 10 Then SUFFIX$ = "000000"
        If Current& = 100 Then SUFFIX$ = "00000"
        If Current& = 1000 Then SUFFIX$ = "0000"
        If Current& = 10000 Then SUFFIX$ = "000"
        If Current& = 100000 Then SUFFIX$ = "00"
        CHKFILE$ = SUFFIX$ + Mid$(Str$(Current&), 2) + ext$
        If _FileExists(CHKFILE$) Then FrameCount = FrameCount + 1
        Current& = Current& + 1
    Loop While _FileExists(CHKFILE$)
    Cls
End Sub


Sub BadCommandLine ()
    Print "USAGE:    MakeMovie  <FRAMEDIR> or <MOVIEFILE>": Print
    System
End Sub

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function

Sub Showit
    Static InShow
    Static Show3&
    Static ImgX%, ImgY%
    If Not InShow Then _ScreenShow
    _Dest _Console
    If Not InShow Then
        mult = 3
        If wid = 192 Then mult = 2.5
        ImgX% = (640 - (wid * mult)) / 2
        ImgY% = 525 - (hei * mult)
        Show& = _NewImage(wid * mult, hei * mult, 32)
        Show2& = _NewImage(wid, hei, 32)
        Show3& = _NewImage(640, 580, 32)
        Screen Show3&: _Title "Converting - " + GetFileName(MovieName$) + GetFileExt(MovieName$) + " (" + Str$(FrameCount) + " frames)"
        Line (ImgX% - 8, ImgY% - 8)-(ImgX% + (wid * mult) + 8, ImgY% + (hei * mult) + 8), _RGB32(100, 110, 100), BF
        Line (ImgX% - 5, ImgY% - 5)-(ImgX% + (wid * mult) + 5, ImgY% + (hei * mult) + 5), _RGB32(45, 35, 45), BF
    End If

    _Dest Show2&
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), VERA2RGB(VERAPAL(ImageData(PixIndx&)))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _PutImage , Show2&, Show&
    _PutImage (ImgX%, ImgY%), Show&, Show3&
    Rem     Screen Show&
    Rem     If Not InShow Then _ScreenShow
    _Dest _Console
    InShow = -1
End Sub

Sub LoadImage (ImgFile$)
    Addquotes = InStr(ImgFile$, Chr$(32)) > 0
    If Not _FileExists(ImgFile$) Then
        _MessageBox "NOT FOUND", ImgFile$ + " NOT FOUND!", "error"
        Print
        BadFile = -1
        System
    End If

    If Addquotes Then ImgFile$ = "'" + ImgFile$ + "'"
    MagickIt ImgFile$, "IN.BMP"
    LOAD_IMAGE_DATA "IN.BMP"

    Kill "IN.BMP"
End Sub


Sub MagickIt (Infile$, Outfile$)
    Dither$ = " -dither FloydSteinberg "
    $If WINDOWS Then
        MAGICK$="magick "
    $Else
        Magick$ = "convert "
    $End If
    Color 15: DualPrintXY "CONVERTING: ", 4, 1
    Color 10
    DualPrint Infile$

    CMD$ = Magick$ + Infile$ + " -compress none "
    Size$ = Mid$(Str$(ImageWidth), 2) + "x" + Mid$(Str$(ImageHeight), 2) + "! "
    CMD$ = CMD$ + " -resize " + Size$
    If UseDither Then CMD$ = CMD$ + Dither$
    CMD$ = CMD$ + " -flip -depth 8 -colors " + UsedCols$ + " -type palette BMP3:" + Outfile$
    DualPrint ""
    Color 7
    DualPrint "EXECUTING"
    Color 6
    DualPrint CMD$
    Shell CMD$
End Sub

Sub LOAD_IMAGE_DATA (INBMP$)
    Dim InPixels As _Unsigned _Byte
    Dim Pix(1 To 8) As _Unsigned _Byte
    Dim Pix1 As _Unsigned _Byte
    Dim Pix2 As _Unsigned _Byte

    Dim USED_Colors(0 To 255) As _Byte
    Dim BmpHeader As BMPHeaderType
    Dim ImageSize As _Unsigned Long
    Dim Pixels As _Unsigned Long
    Dim Pix As _Unsigned _Byte

    Open INBMP$ For Binary As #1
    Get #1, , BmpHeader

    pad = BmpHeader.wid Mod 4
    If pad > 0 Then pad = 4 - pad

    ImageSize = BmpHeader.hei * BmpHeader.wid
    ReDim ImageData(0 To (ImageSize - 1)) As _Unsigned _Byte
    wid = BmpHeader.wid
    hei = BmpHeader.hei

    a$ = BmpHeader.pal ' Pal is stored in a 1024 character string

    I% = 1
    For PI% = 0 To 255
        b% = Asc(Mid$(a$, I%, 1)) \ 16 'blue
        g% = Asc(Mid$(a$, I% + 1, 1)) \ 16 'green
        r% = Asc(Mid$(a$, I% + 2, 1)) \ 16 'red
        ' I% + 3 is set to zero.
        gb% = Int((g% * 16) + b%)
        VERAPAL(PI%).GB = gb%
        VERAPAL(PI%).R = r%
        I% = I% + 4
    Next PI%

    Seek #1, BmpHeader.offset + 1

    If BmpHeader.bpp = 1 Then
        IIndx = 0
        For I = 0 To (ImageSize / 8 - 1)
            Get #1, , InPixels
            For Ji = 1 To 8: Pix(Ji) = 0: Next

            If (InPixels And 128) = 128 Then Pix(1) = 1

            If (InPixels And 64) = 64 Then Pix(2) = 1

            If (InPixels And 32) = 32 Then Pix(3) = 1

            If (InPixels And 16) = 16 Then Pix(4) = 1

            If (InPixels And 8) = 8 Then Pix(5) = 1

            If (InPixels And 4) = 4 Then Pix(6) = 1

            If (InPixels And 2) = 2 Then Pix(7) = 1

            If (InPixels And 1) = 1 Then Pix(8) = 1
            For Ji = 1 To 8
                ImageData(IIndx) = Pix(Ji)
                IIndx = IIndx + 1
            Next
        Next
        GoTo skip8bpp
    End If

    If BmpHeader.bpp = 4 Then
        IIndx = 0
        For I = 0 To (ImageSize / 2 - 1)
            Get #1, , InPixels
            Pix2 = Int(InPixels / 16)
            Pix1 = InPixels And 15
            ImageData(IIndx) = Pix2
            IIndx = IIndx + 1
            ImageData(IIndx) = Pix1
            IIndx = IIndx + 1
        Next
        GoTo skip8bpp
    End If


    If pad = 0 Then
        Get #1, , ImageData()
    Else
        I = 0
        For Y = 1 To BmpHeader.hei
            For x = 1 To BmpHeader.wid
                Get #1, , ImageData(I)
                I = I + 1
            Next x
            For P = 1 To pad: Get #1, , Pix: Next P
        Next Y
    End If

    skip8bpp:
    For I = 0 To 255: USED_Colors(I) = 0: Next
    ColorsUsed = 0

    Rem Count How Many Colors are used in this image
    For I = 0 To ImageSize - 1
        If USED_Colors(ImageData(I)) = 0 Then
            USED_Colors(ImageData(I)) = -1
            ColorsUsed = ColorsUsed + 1
        End If
        If ColorsUsed = 256 Then Exit For
    Next I

    Rem if greater than 252 colors then no point in shifting UP
    If ColorsUsed > 252 Then Close 1: Exit Sub

    Rem Shift Used Colors and Image data UP in the Palette
    Rem fill unused lower indices with VERA default values
    FreeToIndx = (256 - ColorsUsed) - 1

    SCANCOLOR = FreeToIndx + 1

    For ColIndx = 0 To FreeToIndx
        GotSubstituteColor = 0
        For Pixels = 0 To (ImageSize - 1)
            If ImageData(Pixels) = ColIndx Then
                If Not GotSubstituteColor Then
                    U = SCANCOLOR
                    CHECKCOL:
                    If USED_Colors(U) = 0 Then GoTo gotnextcol
                    If U < 255 Then
                        U = U + 1
                        GoTo CHECKCOL
                    End If
                    gotnextcol:
                    SwapPixel = U
                    USED_Colors(U) = -1
                    USED_Colors(ColIndx) = 0
                    VERAPAL(U) = VERAPAL(ColIndx)
                    GotSubstituteColor = -1
                End If
                ImageData(Pixels) = SwapPixel
            End If
        Next Pixels
    Next ColIndx

    Restore VERA_DEFAULT
    For I = 0 To FreeToIndx
        Read VERAPAL(I).GB
        Read VERAPAL(I).R
    Next I
    Close 1
End Sub

Sub GetSprite (X As Integer, Y As Integer)
    GoLine = Y
    SprIndex = 0
    For SLine = 0 To (SprHeight - 1)
        ImgIndex = ((GoLine * ImageWidth)) + (X)
        For I = ImgIndex To (ImgIndex + SprWidth) - 1
            Sprite(SprIndex) = ImageData(I)
            SprIndex = SprIndex + 1
        Next
        GoLine = GoLine + 1
    Next
End Sub

Function GetFileExt$ (FName$)
    DOT$ = "."
    L = Len(FName$)
    TMP$ = ""
    If InStr(1, FName$, DOT$) = 0 Then GoTo Skipall
    For I = L To 1 Step -1
        C$ = Mid$(FName$, I, 1)
        TMP$ = C$ + TMP$
        If C$ = DOT$ Then Exit For
    Next I
    Skipall:
    GetFileExt = TMP$
End Function

Sub DualPrintXY (Text$, Y%, X%)
    _Dest 0
    Locate Y%, X%
    Print Text$;
    _Dest _Console
    Locate Y%, X%
    Print Text$;
End Sub

Sub DualPrint (Text$)
    _Dest 0
    Print Text$
    _Dest _Console
    Print Text$
End Sub

Function GetFileName$ (FName$)
    $If WINDOWS Then
        SLASH$ = "\"
    $Else
        Slash$ = "/"
    $End If

    TMP$ = ""
    T$ = GetFileExt(FName$)
    CUT = Len(T$)
    L = Len(FName$)
    Name$ = Left$(FName$, L - CUT)
    If InStr(1, TName$, Slash$) = 0 Then
        TMP$ = Name$
        GoTo Skiploop
    End If
    For I = Len(Name$) To 1 Step -1
        C$ = Mid$(Name$, I, 1)
        If C$ <> Slash$ Then
            TMP$ = C$ + TMP$
        Else
            Exit For
        End If
    Next I
    Skiploop:
    GetFileName = TMP$
End Function

Function GetFilePath$ (FName$)
    t1$ = GetFileExt(FName$)
    t2$ = GetFileName(FName$)
    L = Len(FName$) - (Len(t1$) + Len(t2$))
    GetFilePath$ = Left$(FName$, L)
End Function


Function IsNum% (PassedText As String)
    text$ = PassedText
    special$ = UCase$(Left$(text$, 2))
    Select Case special$
        Case "&H", "&B", "&O"
            'check for symbols on right side of value
            r3$ = Right$(text$, 3)
            Select Case r3$
                Case "~&&", "~%%", "~%&" 'unsigned int64, unsigned byte, unsigned offset
                    text$ = Left$(text$, Len(text$) - 3)
                Case Else
                    r2$ = Right$(text$, 2)
                    Select Case r2$
                        Case "~&", "##", "%&", "%%", "~%", "&&" 'unsigned long, float, offset, byte, unsigned integer, int64
                            text$ = Left$(text$, Len(text$) - 2)
                        Case Else
                            r$ = Right$(text$, 1)
                            Select Case r$
                                Case "&", "#", "%", "!" 'long, double, integer, single
                                    text$ = Left$(text$, Len(text$) - 1)
                            End Select
                    End Select
            End Select
            check$ = "0123456789ABCDEF"
            If special$ = "&O" Then check$ = "01234567"
            If special$ = "&B" Then check$ = "01"
            temp$ = Mid$(UCase$(text$), 2)
            For I = 1 To Len(temp$)
                If InStr(check$, Mid$(temp$, I, 1)) = 0 Then Exit For
            Next
            If I <= Len(temp$) Then IsNum = -1
        Case Else
            If _Trim$(Str$(Val(text$))) = text$ Then IsNum = -1
    End Select
End Function


