#CONTROLCODES 1
#INCLUDE "STANDARD.DEF"

HSCALE = $9F2A
VSCALE = $9F2B

## FIFOFULL = %10000000
## BIT16.ON = %00100000
## STEREO.ON = %00010000
## VOLMASK = %11110000
## VOLMAX = %11111111
## DefaultVolume = 14
## MaxVolume = 15

VERABASERATE = 48828.15
VERARATEDIVISOR = 128

  PRINT "{ISO ON}"
  GOSUB FIXCURSOR
  SCREEN 1
  COLOR 1,0
  CLS
  PRINT " TESTING FILE SYSTEM"
  GOSUB TestFileSystem
  CLS:PRINT:PRINT
  IF IsHostFS THEN PRINT "{WHT} HOST {GRN}File System Detected":GOTO STARTMOVIE
  PRINT "{WHT} SD-Card {GRN}file System Detected"

STARTMOVIE:
  PRINT
  PRINT "{WHT} ENTER MOVIE NAME ({LIGHT GREEN}Without Extension{WHT}){GRN}: {YEL}";
  LINPUT BASENAME$
  IF BASENAME$="QUIT" OR BASENAME$="quit" OR BASENAME$="EXIT" OR BASENAME$="exit" THEN CLEANUPANDEND

  PRINT
  FRAMEFILE$=BASENAME$+".SPV"
  AUDIOTRACK$=BASENAME$+".SVA"
  F$=FRAMEFILE$:GOSUB FILEEXISTS
  IF NOT FE% THEN PRINT FRAMEFILE$;" NOT FOUND !":SLEEP 180:PRINT:GOTO STARTMOVIE
  F$=AUDIOTRACK$:GOSUB FILEEXISTS
  IF NOT FE% THEN PRINT AUDIOTRACK$;" NOT FOUND !":SLEEP 180:PRINT:GOTO STARTMOVIE

  IF IsHostFS THEN SKIPFAST
     DOS "U0>B3"
     FASTMODE = -1
SKIPFAST:

OPEN 6,8,6,AUDIOTRACK$+",S,R"
OPEN 4,8,4,FRAMEFILE$+",S,R"

  GOSUB GET.VIDEO.HEADER
  GOSUB SET.VIDEO.ATTRIBUTES

  BLOAD "PLAYVIDEO.8BPP.BIN",8,10,$A000
  GOSUB SET.AUDIOCODE
  GOSUB CALCULATE.SPRITES
  GOSUB SET.SPRITECODE

  PRINT
  PRINT "{LIGHT GREEN}PRESS ANY KEY TO CONTINUE !"
  GOSUB WAITFORKEY

  GOSUB PAL2BLACK
  GOSUB SetUpSprites

  SCREEN 0
  COLOR 1,0:CLS

  SCALER=38
  IF FRAMEWIDTH=160 THEN SCALER = 32
  POKE HSCALE, SCALER
  POKE VSCALE, SCALER


ZEROALL:
## Initially zero out the Sprite RAM
  BANK 10
  SYS $A1E2


PLAY.BadApple:
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   POKE R15L, 1
   BANK 10
   SYS $A000
   SYS CLRCHN
   CLOSE 4
   CLOSE 6
   SLEEP 90

CLEANUPANDEND:
   FOR I = 1 TO (NUMSPRITES*2):SPRITE I,0:NEXT
   SCREEN 0
   COLOR 1,6:CLS:BANNER
   BVLOAD "DPAL.BIN",8,1,$FA00
   END


GET.VIDEO.HEADER:
 PRINT
 PRINT " {LIGHT GREEN}READING VIDEO HEADER"
 VHEADER$ = RPT$(32,32)
 A = POINTER(VHEADER$)+1
 POKE X.REG, 4
 SYS CHKIN
 POKE A.REG, 32
 POKE X.REG, PEEK(A)
 POKE Y.REG, PEEK(A+1)
 POKE C.REG, 0
 SYS MACPTR
 SYS CLRCHN
RETURN


SET.VIDEO.ATTRIBUTES:
  ID$ = LEFT$(VHEADER$,4)
  IF ID$ <> "SPRV" THEN PRINT "BAD VIDEO FILE ID {RED}";ID$:PRINT:STOP
  VTYPE = ASC(MID$(VHEADER$,5,1))
  IF VTYPE<>1 THEN PRINT "BAD VIDEO FILE TYPE {RED}";VTYPE:PRINT:STOP
  BPP = ASC(MID$(VHEADER$,6,1))
  IF BPP<>8 THEN PRINT "UNSUPPORTED VIDEO FILE BPP {RED}";BPP:PRINT:STOP
  FPS = ASC(MID$(VHEADER$,7,1))
  SPRWIDTH = ASC(MID$(VHEADER$,8,1))
  SPRHEIGHT = ASC(MID$(VHEADER$,9,1))
  FRAMEWIDTH = ASC(MID$(VHEADER$,10,1)) + (256 * ASC(MID$(VHEADER$,11,1)))
  FRAMEHEIGHT = ASC(MID$(VHEADER$,12,1)) + (256 * ASC(MID$(VHEADER$,13,1)))
  NUMFRAMES = ASC(MID$(VHEADER$,14,1)) + (256 * ASC(MID$(VHEADER$,15,1))) + (65536 * ASC(MID$(VHEADER$,16,1)))
  NUMSPRITES = (FRAMEWIDTH/SPRWIDTH) * (FRAMEHEIGHT/SPRHEIGHT)
  PALSIZE = 512
RETURN

SET.AUDIOCODE:
  CHANNEL = 6
  GOSUB GETFILESIZE
  PRINT
  PRINT "{WHT} AUDIO FILE SIZE IS: {YEL}";FILESIZE
  PRINT
  ASIZE = FILESIZE / NUMFRAMES
  ASIZE = FN ROUND(ASIZE)
  PRINT "{WHT} AUDIOFRAME SIZE IS: {GRN}";ASIZE
  PRINT
  PRINT "{WHT} VERA RATE: {LIGHT GREEN}";
  DRATE = ASIZE*FPS
  VERA.RATE = INT ((DRATE/VERABASERATE) * VERARATEDIVISOR ) - 1
  PRINT VERA.RATE
  PRINT
  PRINT
  APLOOPS = 1
  IF ASIZE < 2048 THEN APLOOPS = 2
  M255 = INT(ASIZE/255)
  AREMAINDER = ASIZE - (255*M255)
  IF AREMAINDER = 0 THEN AREMAINDER = 255:M255 = M255-1
  BANK 10
  POKE R0L, APLOOPS
  POKE R0H, M255
  POKE R1L, AREMAINDER
  POKE R1H, M255
  POKE R2L, AREMAINDER
  BANK 10
  SYS $A201
RETURN

CALCULATE.SPRITES:
  SPR.DATA.SIZE = SPRHEIGHT * SPRWIDTH * (BPP/8)
  SPR.FRAME.SIZE = SPR.DATA.SIZE * NUMSPRITES
  SPR.ATTR.ENDADDR = $FC06 + (NUMSPRITES*8*2)
  SPR.BLOCK2.DATAADDR = (SPR.FRAME.SIZE) + PALSIZE
RETURN

SET.SPRITECODE:
  SBuff255 = INT(SPR.FRAME.SIZE/255)
  SBuffRem = SPR.FRAME.SIZE - (255*SBuff255)
  IF SBuffRem = 0 THEN SBuffRem = 255:SBuff255=SBuff255 - 1
  PRINT
  PRINT "{WHT} FRAME SIZE: {YEL}";SPR.FRAME.SIZE
  PRINT
  PRINT "{WHT} ATTR END ADDR: {LIGHT GREEN}";HEX$(SPR.ATTR.ENDADDR)
  PRINT
  PRINT "{WHT} BLOCK2 DATA ADDR: {LIGHT GREEN}";HEX$(SPR.BLOCK2.DATAADDR)
  PRINT
  PRINT "{WHT} SBUFF255:{GRN}"; SBuff255
  PRINT
  PRINT "{WHT} SBUFF Remainder:{GRN}"; SBuffRem
  PRINT
  PRINT " {WHT}Number of Sprites:{LIGHT GREEN}";NUMSPRITES
  PRINT
  POKE R3L, SBuff255
  POKE R3H, SBuffRem
  POKE R4L, NUMSPRITES
  POKE R5L, FN Lo.Byte(SPR.ATTR.ENDADDR)
  POKE R5H, FN Hi.Byte(SPR.ATTR.ENDADDR)
  POKE R6H, FN Hi.Byte(SPR.BLOCK2.DATAADDR)
  BANK 10
  SYS $A21C
RETURN

SetUpSprites:
   Y1 = 4
   IF FRAMEHEIGHT = 128 THEN Y1=7
   S.WIDTH = -1
   IF SPRWIDTH = 64 THEN S.WIDTH = 3
   IF SPRWIDTH = 32 THEN S.WIDTH = 2
   IF SPRWIDTH = 16 THEN S.WIDTH = 1
   IF SPRWIDTH = 8 THEN S.WIDTH = 0
   IF S.WIDTH = -1 THEN PRINT "SPRITE ERROR: ";SPRWIDTH;" WIDTH VAR":STOP
   S.HEIGHT = -1
   IF SPRHEIGHT = 64 THEN S.HEIGHT = 3
   IF SPRHEIGHT = 32 THEN S.HEIGHT = 2
   IF SPRHEIGHT = 16 THEN S.HEIGHT = 1
   IF SPRHEIGHT = 8 THEN S.HEIGHT = 0
   IF S.HEIGHT = -1 THEN PRINT "SPRITE ERROR: ";SPRHEIGHT;" HEIGHT VAR":STOP
   XORG = 0
   X1 = XORG:VADDR=0
   VADD.ON = (SPR.DATA.SIZE*NUMSPRITES) + PALSIZE
   FOR SPR = 1 TO NUMSPRITES
     SPRMEM SPR,0,VADDR,1
     SPRMEM SPR+NUMSPRITES,0,VADDR+VADD.ON, 1
     VADDR = VADDR + SPR.DATA.SIZE
     SPRITE SPR, 3, 0, 0, S.WIDTH, S.HEIGHT
     SPRITE SPR+NUMSPRITES, 0, 0, 0, S.WIDTH, S.HEIGHT
     MOVSPR SPR, X1,Y1
     MOVSPR SPR+NUMSPRITES, X1, Y1
     X1=X1+SPRWIDTH:IF X1>=XORG + FRAMEWIDTH THEN X1=XORG:Y1=Y1 + SPRHEIGHT
   NEXT
RETURN

WAITFORKEY:
  SYS CLRCHN
WAIT1:
  GET X$:IF X$<>"" THEN WAIT1
GETKEY:
  GET X$
  IF X$="" THEN GETKEY
RETURN

TestFileSystem:
 F$="TESTFILE":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:TESTFILE,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"TESTFILE,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 63
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN

GETFILESIZE:
 OPEN 15,8,15, "T" + CHR$(CHANNEL)
 INPUT#15,A,A$,T,S
 CLOSE 15
 IF A>=20 THEN FILESIZE = 0:RETURN
 FILESIZE=VAL("$"+MID$(A$,9))
 RETURN

#INCLUDE "STANDARD.BI"

SETDEFPAL:
      F$="DPAL.BIN":GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      POKE $9F20, 0
      POKE $9F21, $FA
      POKE $9F22, %00010001
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = 1 TO 256:READ R:READ GB:POKE VERA.DATA0,GB:POKE VERA.DATA0,R:NEXT
      RETURN

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B





